/*
 * Admin mod script. Copyright (C) 2000, Alfred Reynolds.
 * $Id: $
 *
*/

/* 
 * This is an addon for the base plugin for Admin Mod; 
 * 
 * It adds the use of the pointto function for hands free
 * admin commands that can be bound to a key. 
 * 
 * ** As of AM 2.5c, the pointto function is a little buggy
 * ** on linux (crashes server) but WIN32 is rock solid.
 * 
 * This can only handle commands that take the player as 
 * the first command argument (for now). eg. admin_slap <player>
 * 
 * To create a bind for this you would put this in your config.cfg
 * bind S "admin_point admin_slap"
 * 
 * For a 30 minute ban, you would do this:
 * bind B "admin_point admin_ban 30"
 * 
 * For a teleport to a know location (x:123 y:456 z:789) you would 
 * do this:
 * bind T "admin_teleport 123 456 789:    
 *
 *
 * Revisions:
 * 2.50.0 - Created plugin to do SOME commands with pointing.
 * 2.50.1 - Rewrite of plugin to handle ANY command that takes
 *          a playername as the first parameter.
 * 2.50.2 - Updated for AM 2.50d due to limitation with execclient.
 *          execclient will NOT allow admin_ commands to be executed.
 * 2.50.3 - Updated plugin to use new (AM 2.50e) plugin_exec. 
 * 2.50.4 - Added strstripquotes to the admin_point function.
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.4";

public admin_point(HLCommand,HLData,HLUserName,UserIndex) {
 
	//new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
			
	new nPlayer = -1;
	
 	//convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	strstripquotes(Data);
		
	nPlayer = pointto();
	
	if (nPlayer == -1) {  		
		messageex(User, "POINT: Laf. You can't do that to a hostage, you silly bear.", print_chat); // a la Jag ;)
		nPlayer = 0;
	} else if (nPlayer == 0) {
		messageex(User, "POINT: Laf. You can't do that to a wall, you silly bear.", print_chat); // a la Jag ;)
	} else {

		new sPlayer[MAX_NAME_LENGTH];
		new strCommand[MAX_COMMAND_LENGTH];
		new strData[MAX_TEXT_LENGTH];
		new Text[MAX_TEXT_LENGTH];
		new strMessage[MAX_TEXT_LENGTH];

		numtostr(nPlayer, sPlayer);
		strbreak(Data, strCommand, strData, MAX_DATA_LENGTH);
		
		snprintf(strMessage, MAX_DATA_LENGTH, "POINT: Executing %s on player %s", strCommand, sPlayer);	
		messageex(User, strMessage, print_chat); 
		
		snprintf(Text, MAX_DATA_LENGTH, "%s %s", sPlayer, strData);

		plugin_exec(strCommand, Text);
	}
	return PLUGIN_HANDLED;
}

public plugin_init() {
	plugin_registerinfo("Dio's Admin Pointer Plugin","Perform any AdminMod commands by pointing.",STRING_VERSION);
	
	plugin_registercmd("admin_point","admin_point",ACCESS_ALL,"admin_point <command> [<data1..dataN>] : Executes the command on the current pointed to player..");	
	
	return PLUGIN_CONTINUE;
}